$CSF::Enabled=1;
$CSF::BanAt=4;
$CSF::BanTime=10;
RTB_registerPref("Enabled","Connect-Spam Ban","$CSF::Enabled","bool","Server_ConnectSpamBan","1",0,0,"CSF_Tick");
RTB_registerPref("Ban at __ spammed connects","Connect-Spam Ban","$CSF::BanAt","int 3 5","Server_ConnectSpamBan","4",0,0);
RTB_registerPref("Ban time (minutes)","Connect-Spam Ban","$CSF::BanTime","int -1 1440","Server_ConnectSpamBan","10",0,0);
$CSF::Handler=new ScriptObject(SpamHandler);
cancel($CSF::Tick);
package connectspamfix {
	function GameConnection::AutoAdminCheck(%this){
		if(!$CSF::Enabled)return;
		%times=$CSF::Handler.blid[%this.bl_id]++;
		if(%times==$CSF::BanAt){
			%desc="";
			switch($CSF::BanTime){
				case -1:
					%desc="permanent ban";
				case 1:
					%desc="1 minute";
				case 1440:
					%desc="1 day";
				default:
					%desc=$CSF::BanTime SPC "minutes";
			}
			if($CSF::BanTime>1 && $CSF::BanTime<1440){
				%hours=0;
				%minutes=0;
				%time=$CSF::BanTime;
				while(%time>=60){
					%time=%time-60;
					%hours++;
				}
				%minutes=%time;
				%a=%hours SPC "hour";
				%b=%minutes SPC "minute";
				if(%hours==0)%a="";
				if(%hours>1)%a=%a @ "s";
				if(%minutes==0)%b="";
				if(%minutes>1)%b=%b @ "s";
				%msg="";
				if(%hours && %minutes)
					%msg=%a SPC "and" SPC %b;
				else if(%hours && !%minutes)
					%msg=%a;
				else if(%minutes && !%hours)
					%msg=%b;
				%desc=%msg;
			}
			if($CSF::BanTime==0)
				kickblid(%this.bl_id);
			else
				banblid(%this.bl_id,$CSF::BanTime,"You were connecting too many times! ("@ %desc @ ")");
			$CSF::Handler.blid[%this.bl_id]=0;
		}
		return Parent::AutoAdminCheck(%this);
	}
	function destroyServer(){
		$CSF::Handler.delete();
		cancel($CSF::Tick);
		return Parent::destroyServer();
	}
};
deactivatepackage(connectspamfix);
activatepackage(connectspamfix);
function CSF_Tick(){
	cancel($CSF::Tick);
	if(!$CSF::Enabled)return;
	if(!isObject($CSF::Handler))return;
	$CSF::Handler.delete();
	$CSF::Handler=new ScriptObject(SpamHandler);
	$CSF::Tick=schedule(30000,0,CSF_Tick);
}
CSF_Tick();
